// Exemple de programme JAVA qui utilise le pilote JDBC OCI8 d'Oracle
// pour effectuer un SELECT et itrer sur les lignes du rsultat
// Utilisation de PreparedStatement
// Il faut importer le paquetage java.sql pour utiliser JDBC
package ExemplesJDBC;
import java.sql.*;

class ClientPreparedJDBC
{
  public static void main (String args [])
       throws SQLException, java.io.IOException
  {
    // Charger le pilote JDBC d'Oracle
    try
      {Class.forName ("oracle.jdbc.driver.OracleDriver");
      }
    catch(ClassNotFoundException e)
      {System.err.println(" ClassNotFoundException:" + e.getMessage());
      }

    // Connection  une BD
    Connection uneConnection =
      DriverManager.getConnection ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle");

    // Compilation de l'nonc SQL paramtris avec PreparedStatement
    PreparedStatement unEnoncSQL = uneConnection.prepareStatement
      ("SELECT noClient, nomClient "+
       "FROM CLIENT " +
       "WHERE noClient > ?");

    // Spcification du paramtre
    unEnoncSQL.setInt(1,40);

    // Excution du SELECT
    ResultSet rsultatSelect = unEnoncSQL.executeQuery();
    
    // Itrer sur les lignes du rsultat du SELECT et extraire les valeurs
    // des colonnes dans des variables JAVA
    
    while (rsultatSelect.next ()){
      int noClient = rsultatSelect.getInt ("noClient");
      String nomClient = rsultatSelect.getString ("nomClient");

      System.out.println ("Numro du client:" + noClient);
      System.out.println ("Nom du client:" + nomClient);
    }
    unEnoncSQL.close();
    uneConnection.close();
  }
}

