// Utilisation de java.sql.Timestamp avec le type DATE Oracle (contient date+heure)

package ExemplesJDBC;
import java.sql.*;
import java.util.*;

public class ExempleDateTime 
{
  public static void main (String args [])
       throws SQLException, ClassNotFoundException, java.io.IOException
  {
    // Charger le pilote JDBC d'Oracle
    Class.forName ("oracle.jdbc.driver.OracleDriver");

    // Connexion  une BD
    Connection uneConnection =
      DriverManager.getConnection ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle");

      PreparedStatement unEnoncSQL = uneConnection.prepareStatement
        ("INSERT INTO Commande(noCommande,dateCommande,noClient) VALUES(?,?,?)");
        unEnoncSQL.setInt(1,500);
        Calendar maintenant = Calendar.getInstance(); // cre un calendrier grgorien avec date actuelle
        // Conversion en un java.sql.Timestamp pour utilisation avec JDBC
        java.sql.Timestamp dateMaintenant = 
          new java.sql.Timestamp(maintenant.getTime().getTime());
        // Calendar.getTime() retourne un java.util.Date
        // java.util.Date.getTime() retourne le temps en long
        unEnoncSQL.setTimestamp(2,dateMaintenant);
        unEnoncSQL.setInt(3,10);
        int n = unEnoncSQL.executeUpdate();

    unEnoncSQL = uneConnection.prepareStatement
        ("SELECT noCommande,dateCommande,noClient FROM Commande" );
    ResultSet rsultatSelect = unEnoncSQL.executeQuery();
    while (rsultatSelect.next ()){
        int lenoCommande = rsultatSelect.getInt("noCommande");
        java.sql.Timestamp laDate = rsultatSelect.getTimestamp("dateCommande");
        int lenoClient = rsultatSelect.getInt("noClient");
        
        System.out.println ("noCommande:" + lenoCommande);
        System.out.println ("dateCommande:" + laDate);
        System.out.println ("noClient:" + lenoClient);
    }
    // Fermeture de l'nonc et de la connexion
    unEnoncSQL.close();
    uneConnection.close();
  }
}
