// Effets des mises--jour dans un ResultSet sensitive JDBC 2

package ExemplesJDBC;
import java.sql.*;

class ResultSetSensitive
{
    public static void main (String args [])
    throws SQLException, ClassNotFoundException, java.io.IOException
    {
        // Charger le pilote JDBC d'Oracle
        Class.forName ("oracle.jdbc.driver.OracleDriver");

        // Connexion  une BD
        Connection uneConnection =
        DriverManager.getConnection ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle");

        // Cration d'un nonc avec ResultSet dfilable (srollable)
        Statement unEnoncSQL =
        uneConnection.createStatement(
            ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);

        // Excution d'un SELECT
        ResultSet rsultatSelect = unEnoncSQL.executeQuery
        ("SELECT noClient, nomClient, noTlphone FROM CLIENT");
        
        // Affichage des lignes du ResultSet
        int noClient;
        String nomClient;
        String noTlphone;
        System.out.println("ResultSet avant mise--jour");
        System.out.println("Position\tNoClient\tNomClient\tNoTlphone");
        int position = 1;
        while (rsultatSelect.next ()){
            noClient = rsultatSelect.getInt ("noClient");
            nomClient = rsultatSelect.getString ("nomClient");
            noTlphone = rsultatSelect.getString ("noTlphone");
            System.out.println(position+"\t"+noClient+"\t"+nomClient+"\t"+noTlphone);
            position++;
        }
  
        // Exemples de mises--jour par ResultSet updatable
        
        //Positionnement  la premire ligne du ResultSet
        rsultatSelect.first();
        // Mise--jour de la colonne noTlphone de la ligne courante
        rsultatSelect.updateString("noTlphone","(111)111-1111");
        // Effectuer le UPDATE
        rsultatSelect.updateRow();
                
        // Positionnement  la dernire ligne de la table
        rsultatSelect.last();
        // Supprimer la ligne courante
        rsultatSelect.deleteRow();
        
        // Insertion d'une nouvelle ligne
        rsultatSelect.moveToInsertRow();
        rsultatSelect.updateInt("noClient", 100);
        rsultatSelect.updateString("nomClient", "G. Lemoyne-Allaire");
        rsultatSelect.updateString("noTlphone", "911");
        rsultatSelect.insertRow();
        
        
        DatabaseMetaData unDBMD = uneConnection.getMetaData();
        if (unDBMD.othersUpdatesAreVisible(ResultSet.TYPE_SCROLL_SENSITIVE)){
            System.out.println("Les UPDATE des autres sont visibles");
        }
        if (unDBMD.othersDeletesAreVisible(ResultSet.TYPE_SCROLL_SENSITIVE)){
            System.out.println("Les DELETE des autres sont visibles");
        }
        if (unDBMD.othersInsertsAreVisible(ResultSet.TYPE_SCROLL_SENSITIVE)){
            System.out.println("Les INSERT des autres sont visibles");
        }
        if (unDBMD.ownUpdatesAreVisible(ResultSet.TYPE_SCROLL_SENSITIVE)){
            System.out.println("Les UPDATE du ResultSet sont visibles");
        }
        if (unDBMD.ownDeletesAreVisible(ResultSet.TYPE_SCROLL_SENSITIVE)){
            System.out.println("Les DELETE du ResultSet sont visibles");
        }
        if (unDBMD.ownInsertsAreVisible(ResultSet.TYPE_SCROLL_SENSITIVE)){
            System.out.println("Les INSERT du ResultSet sont visibles");
        }
        
        System.out.println("ResultSet aprs mise--jour");
        System.out.println("Position\tNoClient\tNomClient\tNoTlphone");
        position = 1;
        rsultatSelect.beforeFirst();
        while (rsultatSelect.next ()){
            noClient = rsultatSelect.getInt ("noClient");
            nomClient = rsultatSelect.getString ("nomClient");
            noTlphone = rsultatSelect.getString ("noTlphone");
            System.out.println(position+"\t"+noClient+"\t"+nomClient+"\t"+noTlphone);
            position++;
        }

        // Fermeture de l'nonc et de la connexion
        unEnoncSQL.close();
        uneConnection.close();
    }
}