// Exemples de mises--jour dans un ResultSet updatable JDBC 2

package ExemplesJDBC;
import java.sql.*;

class ResultSetUpdatable
{
    public static void main (String args [])
    throws SQLException, ClassNotFoundException, java.io.IOException
    {
        // Charger le pilote JDBC d'Oracle
        Class.forName ("oracle.jdbc.driver.OracleDriver");

        // Connexion  une BD
        Connection uneConnection =
        DriverManager.getConnection ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle");

        // Cration d'un nonc avec ResultSet dfilable (srollable)
        Statement unEnoncSQL =
        uneConnection.createStatement(
            ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);

        // Excution d'un SELECT
        ResultSet rsultatSelect = unEnoncSQL.executeQuery
        ("SELECT noClient, nomClient, noTlphone FROM CLIENT");
        
        // Exemples de mises--jour par ResultSet updatable
        
        //Positionnement  la premire ligne du ResultSet
        rsultatSelect.first();
        // Mise--jour de la colonne noTlphone de la ligne courante
        rsultatSelect.updateString("noTlphone","(111)111-1111");
        // Effectuer le UPDATE
        rsultatSelect.updateRow();
                
        // Positionnement  la dernire ligne de la table
        rsultatSelect.last();
        // Supprimer la ligne courante
        rsultatSelect.deleteRow();
        
        // Insertion d'une nouvelle ligne
        rsultatSelect.moveToInsertRow();
        rsultatSelect.updateInt("noClient", 100);
        rsultatSelect.updateString("nomClient", "G. Lemoyne-Allaire");
        rsultatSelect.updateString("noTlphone", "911");
        rsultatSelect.insertRow();
        
        // Fermeture de l'nonc et de la connexion
        unEnoncSQL.close();
        uneConnection.close();
    }
}